#include <iostream>
#include "cassert"
#include "vector"
#include "set"

using namespace std;

#ifdef WIN64
void print(int* ar, int sz) {
    for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}
#define check(x) cerr << (#x) << " = " << x << "\n"
#else
void print(int* ar, int sz) {}
#define check(x) 17
#endif

using ll = long long;

const ll INFll = (ll) 1e12 + 117;
const int N = (int)3001;
const int MOD = (int) 1e9 + 7;

int n, q, a[N];
bool used[N]{};
int ans[N][N]{};
set<pair<int, int>> st;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    assert(cin >> n >> q);

    for (int i = 0; i < n; ++i) assert(cin >> a[i]);

    for (int i = 0; i < n; ++i) {
        fill(used, used + n, 0);
        used[i] = 1;

        int t = 0;

        ans[i][t++]++;

        if (i - 1 >= 0) st.insert({a[i - 1], i - 1});
        if (i + 1 < n) st.insert({a[i + 1], i + 1});

        while (!st.empty()) {
            int v = st.begin()->second;
            used[v] = 1;
            st.erase(st.begin());
            ans[v][t++]++;

            if (v - 1 >= 0 && !used[v - 1]) st.insert({a[v - 1], v - 1});
            if (v + 1 < n && !used[v + 1]) st.insert({a[v + 1], v + 1});
        }
    }

    while (q--) {
        int p, k;
        assert(cin >> p >> k);
        p--, k--;
        cout << ans[p][k] << "\n";
    }
}