#include <iostream>
#include "cassert"
#include "vector"

using namespace std;

#ifdef WIN64
    void print(int* ar, int sz) {
        for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
        cerr << "\n";
    }

#else
    void print(int* ar, int sz) {}
#endif

using ll = long long;

const ll INFll = (ll) 1e12 + 117;
const int N = (int)101;
const int MOD = (int) 1e9 + 7;

inline int sum(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

inline int mul(int a, int b) {
    return ((ll)a * b) % MOD;
}

int n, m;
vector<int> a;

int dp[N][10][10]{};

inline int solve() {
    for (int i = 0; i < 2; ++i) {
        for (int aa = 0; aa <= m; ++aa) {
            for (int bb = 0; bb <= m; ++bb) {
                if (aa != bb || i == 0) {
                    dp[i][aa][bb] = 1;
                }
            }
        }
    }

    for (int i = 2; i <= n; ++i) {
        for (int aa = 0; aa <= m; ++aa) {
            for (int bb = 0; bb <= m; ++bb) {
                if (aa != bb) {
                    for (int k = min(1, aa); i - k >= 0; ++k) {
                        for (int cc = 1; cc <= m; ++cc) {
                            if (cc != bb) {
                                dp[i][aa][bb] = sum(dp[i][aa][bb],
                                                    mul(dp[i - k][aa][bb], dp[k - 1][cc][aa]));
                            }
                        }
                    }
                }
            }
        }
    }

    for (int  j = 0; j <= n; ++j) {
        for (int i = 0; i <= m; ++i) print(dp[j][i], m + 1);
        print((int *) "", 0);
    }

    int ans = 0;

    for (int i = 1; i <= m; ++i) ans = sum(ans, dp[n][i][0]);

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    assert(cin >> n >> m);
    a.assign(m + 1, 0);
    for (int i = 1; i <= m; ++i) assert(cin >> a[i]);

    cout << solve() << "\n";

    if (a.size() == 3 && a.back() == 2 && n <= 10) {
        int res = 0;
        for (unsigned mask = 0; mask < (1 << n); ++mask) {
            bool all = 1;

            for (int i = 0; i < n - 1; ++i) if (((mask >> i) & 1) && ((mask >> (i + 1)) & 1)) all = 0;

            if (all) {
                //cout << mask << "\n";
                res++;
            }
        }
        cout << res << "\n";
    }

    return 0;
}
